<?php

 #########################################################################################
 #
 # Nom              : class_webstat.php
 # Auteur           : Spin0us (spin0us@altern.org)
 # Date de creation : lundi 25 janvier 2005, 09h34
 #
 # Version          : 1.2.1 2005/01/25 16:12 Spin0us
 #
 #########################################################################################

 #########################################################################################
 #
 # Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 # de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 # ou bien toute autre version ultrieure choisie par vous).
 #
 #########################################################################################

 class webstat {
 	
 	### ATTRIBUTS DE LA CLASSE #######################################################

 	var $stat_file;                      # Chemin d'accs du fichier de stats
 	var $creation_date;                  # Date de cration 
 	var $tot_visit = 0;                  # Total des visiteurs
 	var $day_visit = 0;                  # Visiteurs par jour
 	var $archive = array();              # Archives des stats



 	### METHODES DE LA CLASSE ########################################################

 	### Constructeur
 	function webstat($path, $cdate) {
 		$this->stat_file = $path . "webstat";
 		$this->creation_date = $cdate;
 		$this->restore();
 		$this->add_hit();
 		$this->add_visit();
 		$this->day_visit = ceil($this->tot_visit / ceil((mktime() - $this->creation_date) / 3600 / 24));
		$this->store();
 	}


 	### Lecture dans le fichier de stats
 	function restore() {
		### Si le fichier n'existe pas
 		if(!file_exists($this->stat_file)) {
 			$handle = fopen($this->stat_file, "w");
 			fputs($handle, $this->creation_date."::0");
 			fputs($handle,"\n".date("Y")."::".date("m")."::0::0");
 			fclose($handle);
 		}
 		
 		$handle = fopen($this->stat_file, "r");
 		list($this->creation_date, $this->tot_visit) = explode("::",trim(fgets($handle)));
 		while(!feof($handle)) {
 			list($year,$month,$visit,$hits) = explode("::",trim(fgets($handle)));
 			$this->archive[$year][$month] = $visit.'::'.$hits;
 		}
 		fclose($handle);
 	}


 	### Ecriture dans le fichier de stats
 	function store() {
 		$handle = fopen($this->stat_file, "w");
 		fputs($handle, $this->creation_date."::".$this->tot_visit);
 		foreach($this->archive as $year=>$val) {
 			foreach($this->archive[$year] as $month=>$cel) {
 				list($visit,$hits) = explode("::", $cel);
 				fputs($handle,"\n".$year."::".$month."::".$visit."::".$hits);
 			}
 		}
 		fclose($handle);
 	}


 	### Ajout d'une visite
 	function add_visit() {
		if(file_exists($this->stat_file."_cache")
		&& (date("Ymd",filemtime($this->stat_file."_cache")) != date("Ymd")) )
			unlink($this->stat_file."_cache");

 		if(!file_exists($this->stat_file."_cache")) {
 			$handle = fopen($this->stat_file."_cache", "w");
 			fputs($handle,$_SERVER['REMOTE_ADDR']."|");
 			fclose($handle);
	 		$this->tot_visit ++;
	 		list($visit,$hits) = explode("::",$this->archive[date("Y")][date("m")]);
 			$visit ++;
 			$this->archive[date("Y")][date("m")] = $visit."::".$hits;
 		} else {
 			$handle = fopen($this->stat_file."_cache", "r");
 			$content = fread($handle,filesize($this->stat_file."_cache"));
 			fclose($handle);
 			if(strpos($content,$_SERVER['REMOTE_ADDR']) === FALSE) {
	 			$handle = fopen($this->stat_file."_cache", "a");
 				fputs($handle,$_SERVER['REMOTE_ADDR']."|");
	 			fclose($handle);
		 		$this->tot_visit ++;
		 		list($visit,$hits) = explode("::",$this->archive[date("Y")][date("m")]);
		 		$visit ++;
		 		$this->archive[date("Y")][date("m")] = $visit."::".$hits;
 			}
 		}
 	}


 	### Ajout d'un hit (page vue)
 	function add_hit() {
 		list($visit,$hits) = explode("::",$this->archive[date("Y")][date("m")]);
 		$hits ++;
 		$this->archive[date("Y")][date("m")] = $visit."::".$hits;
 	}


 	### Affichage de la date de creation
 	function get_creationdate() { return date("l, d F Y H:i:s T",$this->creation_date); }
 	### Affichage du total des visites
 	function get_totvisit() { return $this->tot_visit; }
 	### Affichage des visiteurs par jour
 	function get_dayvisit() { return $this->day_visit; }
 	### Affichage des hits (pages vues)
 	function get_hits() {
 		list($visit,$hits) = explode("::",$this->archive[date("Y")][date("m")]);
 		return $hits;
 	}
 }

?>